import { defineComponent as q, useAttrs as J, ref as Q, shallowRef as g, computed as l, watch as X, onMounted as Z, nextTick as i, openBlock as E, createElementBlock as w, normalizeClass as V, createElementVNode as $, mergeProps as ee, unref as m, normalizeStyle as ae, toDisplayString as C, createCommentVNode as te } from "vue";
import { Props as oe } from "./index3.js";
import { calcTextareaHeight as N } from "./index4.js";
import { isEmpty as re, isClient as le, isObject as T } from "../../../utils/lodash/index2.js";
import { useCursor as se } from "../../../hooks/index23.js";
import { UPDATE_MODEL_EVENT as p, CHANGE_EVENT as f, INPUT_EVENT as v, BLUR_EVENT as S, FOCUS_EVENT as z } from "../../../constants/index2.js";
import { warning as ne } from "../../../utils/console/index.js";
import { useNamespace as ue } from "../../../hooks/index24.js";
const ce = ["tabindex", "disabled", "readonly", "autocomplete", "aria-label", "placeholder", "autofocus"];
var xe = /* @__PURE__ */ q({
  name: "FzTextarea",
  __name: "textarea",
  props: oe,
  emits: [
    p,
    f,
    v,
    S,
    z,
    "keydown",
    "clear"
  ],
  setup(_, { expose: k, emit: o }) {
    const a = _, s = ue("textarea"), I = J(), R = Q(), r = g(), u = g({}), n = l(
      () => re(a.modelValue) ? "" : String(a.modelValue)
    ), h = l(() => n.value.length), d = l(() => a.disabled), y = l(
      () => !!a.maxlength && !d.value && !a.readonly
    ), B = l(
      () => (
        // show exceed style if length of initial value greater then maxlength
        !!y.value && h.value > Number(a.maxlength)
      )
    ), F = l(() => [
      a.textareaStyle,
      u.value,
      { resize: a.resize }
    ]), H = l(() => [
      s.b(),
      s.is("disabled", d.value),
      s.is("exceed", B.value)
    ]), [L, D] = se(r), c = () => {
      const e = r.value, t = a.formatter ? a.formatter(n.value) : n.value;
      !e || e.value === t || (e.value = t);
    }, x = () => {
      const { autosize: e } = a;
      if (le)
        if (e) {
          const t = T(e) ? e.minRows : void 0, Y = T(e) ? e.maxRows : void 0, b = N(r.value, t, Y);
          u.value = {
            overflowY: "hidden",
            ...b
          }, i(() => {
            r.value.offsetHeight, u.value = b;
          });
        } else
          u.value = {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            minHeight: N(r.value).minHeight
          };
    }, P = async (e) => {
      L();
      let { value: t } = e.target;
      if (a.formatter && (t = a.parser ? a.parser(t) : t), t === n.value) {
        c();
        return;
      }
      o(p, t), o(v, t), await i(), c(), D();
    }, U = (e) => {
      o(f, e.target.value);
    }, A = (e) => {
      o("keydown", e);
    }, O = (e) => {
      o(S, e);
    }, K = (e) => {
      o(z, e);
    }, M = () => {
      var e;
      (e = r.value) == null || e.select();
    }, j = () => {
      o(p, ""), o(f, ""), o(v, ""), o("clear");
    }, G = async () => {
      var e;
      await i(), (e = r.value) == null || e.focus();
    }, W = () => {
      var e;
      return (e = r.value) == null ? void 0 : e.blur();
    };
    return X(n, () => c()), Z(() => {
      !a.formatter && a.parser && ne("FzTextarea", "If you set the parser, you also need to set the formatter."), c(), i(x);
    }), k({
      textarea: r,
      /**  HTML input element native method */
      focus: G,
      /**  HTML input element native method */
      blur: W,
      /**  HTML input element native method */
      select: M,
      /**  clear input value */
      clear: j,
      /**  resize textarea. */
      resizeTextarea: x
    }), (e, t) => (E(), w("div", {
      class: V(H.value)
    }, [
      $("textarea", ee({
        ref_key: "textarea",
        ref: r,
        class: m(s).e("inner"),
        style: F.value
      }, m(I), {
        tabindex: e.tabindex,
        disabled: d.value,
        readonly: e.readonly,
        autocomplete: e.autocomplete,
        "aria-label": e.label,
        placeholder: e.placeholder,
        autofocus: e.autofocus,
        onInput: P,
        onFocus: K,
        onBlur: O,
        onChange: U,
        onKeydown: A
      }), null, 16, ce),
      y.value ? (E(), w("span", {
        key: 0,
        style: ae(R.value),
        class: V(m(s).e("count"))
      }, C(h.value) + " / " + C(e.maxlength), 7)) : te("", !0)
    ], 2));
  }
});
export {
  xe as default
};
