export declare const isClient: boolean;
export declare const isFirefox: () => boolean;
export declare const isBoolean: (val: any) => boolean;
export declare const isNumber: (val: any) => boolean;
export declare const isUndefined: (val: any) => boolean;
export declare const hasOwn: (val: object, key: string | symbol) => key is never;
export declare const isArray: (arg: any) => arg is any[];
export declare const isMap: (val: unknown) => val is Map<any, any>;
export declare const isSet: (val: unknown) => val is Set<any>;
export declare const isDate: (val: unknown) => val is Date;
export declare const isRegExp: (val: unknown) => val is RegExp;
export declare const isFunction: (val: unknown) => val is Function;
export declare const isString: (val: any) => boolean;
export declare const isSymbol: (val: any) => boolean;
export declare const isObject: (val: unknown) => val is Record<any, any>;
export declare const isPromise: <T = any>(val: unknown) => val is Promise<T>;
export declare const isEmpty: (val: any) => boolean;
export declare const isElement: (e: unknown) => e is Element;
